當我在解決leetcode上的問題時,它說在給定的按非遞減順序排序的整數nums數組中,找到給定目標值的開始和結束位置。因此不可能用簡單的二進位 Sarch 來傳回數組中目標元素的開始和結束,因為它只傳回找到第一個目標元素的索引,該元素可以是該元素的第一個、結尾或中間的任何內容。所以我們使用 Double Binary Scarch ,這是如何做到的...
第一次二分查找:
第二次二分查找:
回傳結果:
時間複雜度:
空間複雜度:
class Solution { public int[] searchRange(int[] nums, int target) { int ei = nums.length - 1; int si = 0; int[] res = {-1, -1}; // Initialize result array // First binary search to find the last occurrence while (si nums[mid]) { si = mid 1; } else { res[1] = mid; // Update end index si = mid 1; // Search in the right half } } // Reset the pointers for the second binary search si = 0; ei = nums.length - 1; // Second binary search to find the first occurrence while (si nums[mid]) { si = mid 1; } else { res[0] = mid; // Update start index ei = mid - 1; // Search in the left half } } return res; // Return the result array } }
免責聲明: 提供的所有資源部分來自互聯網,如果有侵犯您的版權或其他權益,請說明詳細緣由並提供版權或權益證明然後發到郵箱:[email protected] 我們會在第一時間內為您處理。
Copyright© 2022 湘ICP备2022001581号-3